Game Develop C++ Platform: TiXmlElement Class Reference

| Game Develop C++ Platform Platform for developing native games based on OpenGL and SFML with Game Develop

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Groups Pages
Public Member Functions | Protected Member Functions | List of all members
TiXmlElement Class Reference
Integrated TinyXml library

Part of the tinyxml library. More...

`#include <tinyxml.h>`

Inheritance diagram for TiXmlElement:
[legend]
Collaboration diagram for TiXmlElement:
[legend]

## Public Member Functions

| TiXmlElement (const char *in_value)
| Construct an element.
| TiXmlElement (const TiXmlElement &)
void | operator= (const TiXmlElement &base)
const char * | Attribute (const char *name) const
const char * | Attribute (const char *name, int *i) const
const char * | Attribute (const char *name, double *d) const
int | QueryIntAttribute (const char *name, int *_value) const
int | QueryDoubleAttribute (const char *name, double *_value) const
| QueryDoubleAttribute examines the attribute - see QueryIntAttribute().
int | QueryFloatAttribute (const char *name, float *_value) const
| QueryFloatAttribute examines the attribute - see QueryIntAttribute().
void | SetAttribute (const char *name, const char *_value)
void | SetAttribute (const char *name, int value)
void | SetDoubleAttribute (const char *name, double value)
void | RemoveAttribute (const char *name)
const TiXmlAttribute * | FirstAttribute () const
| Access the first attribute in this element.
TiXmlAttribute * | FirstAttribute ()
const TiXmlAttribute * | LastAttribute () const
| Access the last attribute in this element.
TiXmlAttribute * | LastAttribute ()
const char * | GetText () const
virtual TiXmlNode * | Clone () const
| Creates a new Element and returns it - the returned element is a copy.
virtual void | Print (FILE *cfile, int depth) const
virtual const char * | Parse (const char *p, TiXmlParsingData *data, TiXmlEncoding encoding)
virtual const TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null not of the requested type.
virtual TiXmlElement * | ToElement ()
| Cast to a more defined type. Will return null not of the requested type.
virtual bool | Accept (TiXmlVisitor *visitor) const
Public Member Functions inherited from TiXmlNode
const char * | Value () const
const TIXML_STRING & | ValueTStr () const
void | SetValue (const char *_value)
void | Clear ()
| Delete all the children of this node. Does not affect 'this'.
TiXmlNode * | Parent ()
| One step up the DOM.
const TiXmlNode * | Parent () const
const TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children.
TiXmlNode * | FirstChild ()
const TiXmlNode * | FirstChild (const char *value) const
TiXmlNode * | FirstChild (const char *_value)
| The first child of this node with the matching 'value'. Will be null if none found.
const TiXmlNode * | LastChild () const
TiXmlNode * | LastChild ()
| The last child of this node. Will be null if there are no children.
const TiXmlNode * | LastChild (const char *value) const
TiXmlNode * | LastChild (const char *_value)
| The last child of this node matching 'value'. Will be null if there are no children.
const TiXmlNode * | IterateChildren (const TiXmlNode *previous) const
TiXmlNode * | IterateChildren (const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const char *value, const TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'.
TiXmlNode * | IterateChildren (const char *_value, const TiXmlNode *previous)
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node.
const TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node.
TiXmlNode * | PreviousSibling ()
const TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node.
TiXmlNode * | PreviousSibling (const char *_prev)
const TiXmlNode * | NextSibling () const
| Navigate to a sibling node.
TiXmlNode * | NextSibling ()
const TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'.
TiXmlNode * | NextSibling (const char *_next)
const TiXmlElement * | NextSiblingElement () const
TiXmlElement * | NextSiblingElement ()
const TiXmlElement * | NextSiblingElement (const char *) const
TiXmlElement * | NextSiblingElement (const char *_next)
const TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements.
TiXmlElement * | FirstChildElement ()
const TiXmlElement * | FirstChildElement (const char *_value) const
| Convenience function to get through elements.
TiXmlElement * | FirstChildElement (const char *_value)
int | Type () const
const TiXmlDocument * | GetDocument () const
TiXmlDocument * | GetDocument ()
bool | NoChildren () const
| Returns true if this node has no children.
virtual const TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual const TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual const TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual const TiXmlText * | ToText () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual const TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlDocument * | ToDocument ()
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlComment * | ToComment ()
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlUnknown * | ToUnknown ()
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlText * | ToText ()
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlDeclaration * | ToDeclaration ()
| Cast to a more defined type. Will return null if not of the requested type.
Public Member Functions inherited from TiXmlBase
int | Row () const
int | Column () const
| See Row()
void | SetUserData (void *user)
| Set a pointer to arbitrary user data.
void * | GetUserData ()
| Get a pointer to arbitrary user data.
const void * | GetUserData () const
| Get a pointer to arbitrary user data.

## Protected Member Functions

void | CopyTo (TiXmlElement *target) const
void | ClearThis ()
const char * | ReadValue (const char *in, TiXmlParsingData *prevData, TiXmlEncoding encoding)
Protected Member Functions inherited from TiXmlNode
| TiXmlNode (NodeType _type)
void | CopyTo (TiXmlNode *target) const
TiXmlNode * | Identify (const char *start, TiXmlEncoding encoding)

## Additional Inherited Members

Public Types inherited from TiXmlNode
enum | NodeType { DOCUMENT, ELEMENT, COMMENT, UNKNOWN, TEXT, DECLARATION, TYPECOUNT }
Static Public Member Functions inherited from TiXmlBase
static void | SetCondenseWhiteSpace (bool condense)
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting.
static void | EncodeString (const TIXML_STRING &str, TIXML_STRING *out)
Static Public Attributes inherited from TiXmlBase
static const int | utf8ByteTable [256]
Static Protected Member Functions inherited from TiXmlBase
static const char * | SkipWhiteSpace (const char *, TiXmlEncoding encoding)
static bool | IsWhiteSpace (char c)
static bool | IsWhiteSpace (int c)
static const char * | ReadName (const char *p, TIXML_STRING *name, TiXmlEncoding encoding)
static const char * | ReadText (const char *in, TIXML_STRING *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static const char * | GetEntity (const char *in, char *value, int *length, TiXmlEncoding encoding)
static const char * | GetChar (const char *p, char *_value, int *length, TiXmlEncoding encoding)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static int | IsAlpha (unsigned char anyByte, TiXmlEncoding encoding)
static int | IsAlphaNum (unsigned char anyByte, TiXmlEncoding encoding)
static int | ToLower (int v, TiXmlEncoding encoding)
static void | ConvertUTF32ToUTF8 (unsigned long input, char *output, int *length)
Protected Attributes inherited from TiXmlNode
TiXmlNode * | parent
NodeType | type
TiXmlNode * | firstChild
TiXmlNode * | lastChild
TIXML_STRING | value
TiXmlNode * | prev
TiXmlNode * | next
Static Protected Attributes inherited from TiXmlBase
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Detailed Description

Part of the tinyxml library.

The element is a container class. It has a value, the element name, and can contain other elements, text, comments, and unknowns. Elements also contain an arbitrary number of attributes.

## Member Function Documentation

bool TiXmlElement::Accept | ( | TiXmlVisitor * | visitor) |  | const

virtual

Walk the XML tree visiting this node and all of its children.

Implements TiXmlNode.

Here is the call graph for this function:

const char * TiXmlElement::Attribute | ( | const char * | name) |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists.

Here is the call graph for this function:

const char * TiXmlElement::Attribute | ( | const char * | name,
|  | int * | i
| ) |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. If the attribute exists and can be converted to an integer, the integer value will be put in the return 'i', if 'i' is non-null.

Here is the call graph for this function:

const char * TiXmlElement::Attribute | ( | const char * | name,
|  | double * | d
| ) |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. If the attribute exists and can be converted to an double, the double value will be put in the return 'd', if 'd' is non-null.

Here is the call graph for this function:

const char * TiXmlElement::GetText | ( | ) |  | const

Convenience function for easy access to the text inside an element. Although easy and concise, GetText() is limited compared to getting the TiXmlText child and accessing it directly.

If the first child of 'this' is a TiXmlText, the GetText() returns the character string of the Text node, else null is returned.

This is a convenient method for getting the text of simple contained text:

        <foo>This is text</foo>
        const char* str = fooElement->GetText();

'str' will be a pointer to "This is text".

Note that this function can be misleading. If the element foo was created from this XML:

        <foo><b>This is text</b></foo>

then the value of str would be null. The first child node isn't a text node, it is another element. From this XML:

        <foo>This is <b>text</b></foo>

GetText() will return "This is ".

WARNING: GetText() accesses a child node - don't become confused with the similarly named TiXmlHandle::Text() and TiXmlNode::ToText() which are safe type casts on the referenced node.

Here is the call graph for this function:

void TiXmlElement::Print | ( | FILE * | cfile,
|  | int | depth
| ) |  | const

virtual

All TinyXml classes can print themselves to a filestream or the string class (TiXmlString in non-STL mode, std::string in STL mode.) Either or both cfile and str can be null.

This is a formatted print, and will insert tabs and newlines.

(For an unformatted stream, use the << operator.)

Implements TiXmlBase.

Here is the call graph for this function:

int TiXmlElement::QueryIntAttribute | ( | const char * | name,
|  | int * | _value
| ) |  | const

QueryIntAttribute examines the attribute - it is an alternative to the Attribute() method with richer error checking. If the attribute is an integer, it is stored in 'value' and the call returns TIXML_SUCCESS. If it is not an integer, it returns TIXML_WRONG_TYPE. If the attribute does not exist, then TIXML_NO_ATTRIBUTE is returned.

Here is the call graph for this function:

void TiXmlElement::RemoveAttribute | ( | const char * | name) |  |

Deletes an attribute with the given name.

void TiXmlElement::SetAttribute | ( | const char * | name,
|  | const char * | _value
| ) |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

Here is the call graph for this function:

void TiXmlElement::SetAttribute | ( | const char * | name,
|  | int | value
| ) |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

Here is the call graph for this function:

void TiXmlElement::SetDoubleAttribute | ( | const char * | name,
|  | double | value
| ) |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- tinyxml.h
- tinyxml.cpp
- tinyxmlparser.cpp